=== debian/changelog ===
timescaledb (2.23.0+dfsg-1.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 29 Oct 2025 17:09:59 +0100

timescaledb (2.23.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.23.0+dfsg.
  * Upload for PostgreSQL 18. (Closes: #1117342)
  * Add ${postgresql:Breaks}.
  * debian/tests: Depend on postgresql-common-dev instead of 'make'.

 -- Christoph Berg <myon@debian.org>  Wed, 29 Oct 2025 17:09:59 +0100
