=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with pgxs

override_dh_auto_configure:
	set -ex; for v in $(shell pg_buildext supported-versions); do \
		dh_auto_configure -Bbuild-$$v -- \
			-DCMAKE_BUILD_TYPE=RelWithDebInfo \
			-DPG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config \
			-DSEND_TELEMETRY_DEFAULT=OFF \
			-DUSE_TELEMETRY=OFF \
			-DAPACHE_ONLY=1; \
	done

override_dh_installdocs:
	dh_installdocs --all README.* NOTICE

override_dh_pgxs_test:
	# defer testing to autopkgtest
