=== debian/tests/control ===
Depends:
 build-essential,
 cmake,
 libipc-run-perl,
 postgresql-common-dev,
 postgresql-server-dev-all,
 tzdata-legacy,
 @,
Tests:
 installcheck,
Restrictions:
 allow-stderr,
