=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg \
https://github.com/timescale/timescaledb/tags .*/(.*).tar.gz
