## timescaledb 2.23.1%2Bdfsg

=== debian/changelog ===
timescaledb (2.23.1+dfsg-1.pgdg22.04+1) jammy-pgdg; urgency=medium

  * Rebuild for jammy-pgdg.
  * Changes applied by generate-pgdg-source:
    + Remove tzdata-legacy from build and test dependencies.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Thu, 13 Nov 2025 18:59:33 +0100

timescaledb (2.23.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.23.1+dfsg.

 -- Christoph Berg <myon@debian.org>  Thu, 13 Nov 2025 18:59:33 +0100
