=== debian/tests/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
  libipc-run-perl,
  postgresql-common-dev,
  postgresql-server-dev-all,
- tzdata-legacy,
+ tzdata,
  @,
 Tests:
  installcheck,
