=== debian/changelog ===
timescaledb (2.24.0+dfsg-1.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 03 Dec 2025 13:05:11 +0100

timescaledb (2.24.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.24.0+dfsg.

 -- Christoph Berg <myon@debian.org>  Wed, 03 Dec 2025 13:05:11 +0100
